
(sal/load-source! "sal-script-util.scm")

(define *output-file* #f)

(front-end/add-simple-option! "Misc" "--output=<file-name>"
															"Sets the output file that will contain the result."
															(lambda (arg) 
																(set! *output-file* arg)))

(front-end/set-categories! '("Help" "Misc" "Assertion" "Pretty Printing" "Code Transformations" "Abstraction" "Traceability"))


(gen-front-end sal2bool
							 "SAL boolean transition relation generator"
							 "Usage: sal2bool [options] <context-name> <assertion-name>"
"Examples:
  sal2bool mutex mutual-exclusion

  sal2bool --assertion='arbiter{;10}!at_most_one_ack'

  sal2bool --assertion='(@ at-most-one-ack (arbiter () (10)))'"
(lambda (else)
	(if *main-context-name*
		(if *main-assertion-name*
			(begin 
				(print "Illegal argument `" else "'. Usage:")
				(sal2bool/simple-help))
			(set! *main-assertion-name* else))
		(set! *main-context-name* else)))
(begin
	(check-assertion-name-ref sal2bool/simple-help)
	(sal/set-make-sal-string-reader-proc! make-lsal-string-reader)
	(let ((assertion-qualified-name (or *assertion*
																			(string-append "(@ " *main-assertion-name* " " *main-context-name* ")"))))
		(guess-qualified-name-parser! assertion-qualified-name)
		(let ((assertion (sal-ast/rename-variables (make-boolean-assertion assertion-qualified-name))))
			(if *output-file*
				(with-output-to-file *output-file* (lambda () (pp (sal-ast->list assertion))))
				(pp (sal-ast->list assertion)))))))

(sal2bool/main)
